<?php
if( !isset ($_SERVER['PHP_AUTH_USER'])) {
	header("WWW-Authenticate: Basic realm=\"My Realm\"");
	header("HTTP/1.0 401 Unauthorized");

	die('このページを見るにはログインが必要です');
} 
else {

include_once('config.php');
include_once( INSTALL_PATH . '/DBRecord.class.php' );
include_once( INSTALL_PATH . '/Smarty/Smarty.class.php' );
include_once( INSTALL_PATH . '/Settings.class.php' );

$settings = Settings::factory();


// 検索表示する番組は27時間前以降に始まってまだ終了時間のきていないもの
$options = " WHERE starttime > '".date("Y-m-d H:i:s", time() - 97200 )."' AND endtime > '".date("Y-m-d H:i:s", time())."'";

$search = "";

$stime = "";

$use_regexp = 0;
$type = "*";
$category_id = 0;
$station = 0;
$lines = 12;

// 残容量の算出 
$disk = INSTALL_PATH.$settings->spool;
$free_size = sprintf("%01.3f",disk_free_space( $disk )/1024/1024/1024);
$remain_1= sprintf("%01.2f", $free_size/8); // 残り時間(1h=8Gbytes)
$remain_h = floor( $remain_1 );
$remain_m = floor (($remain_1 - $remain_h)*60);
$remain_t=sprintf("%3d:%02d",$remain_h,$remain_m);

$username=$_SERVER['PHP_AUTH_USER'];

// mysql_real_escape_stringより先に接続しておく必要がある
$dbh = @mysql_connect($settings->db_host, $settings->db_user, $settings->db_pass );

	// パラメータの処理

if(isset( $_POST['do_stime'] )) {
	if( isset($_POST['stime'])){
		if( $_POST['stime'] != "" ) {
			$stime = $_POST['stime'];
//				$options = " WHERE starttime > '".date("Y-m-d H:i:s", mktime($stime -1 , 59, 59) )."' AND endtime > '".date("Y-m-d H:i:s", time())."'";
				$options = " WHERE ( starttime > '".date("Y-m-d H:i:s", mktime($stime -1 , 59, 59) )."' OR starttime > '".date("Y-m-d H:i:s", time() - 97200 )."') AND endtime > '".date("Y-m-d H:i:s", mktime($stime,0,3))."'";
			}
			else {
				$options = " WHERE starttime > '".date("Y-m-d H:i:s", time() - 97200 )."' AND endtime > '".date("Y-m-d H:i:s", time())."'";
			}
		}
	}



if(isset( $_POST['do_search'] )) {
	if( isset($_POST['search'])){
		if( $_POST['search'] != "" ) {
			$search = $_POST['search'];
			if( isset($_POST['use_regexp']) && ($_POST['use_regexp']) ) {
				$use_regexp = $_POST['use_regexp'];
				$options .= " AND CONCAT(title,description) REGEXP '".mysql_real_escape_string($search)."'";
			}
			else {
				$options .= " AND CONCAT(title,description) like '%".mysql_real_escape_string($search)."%'";
			}
		}
	}
	if( isset($_POST['type'])){
		if( $_POST['type'] != "*" ) {
			$type = $_POST['type'];
			$options .= " AND type = '".$_POST['type']."'";
		}
	}
	if( isset($_POST['category_id'])) {
		if( $_POST['category_id'] != 0 ) {
			$category_id = $_POST['category_id'];
			$options .= " AND category_id = '".$_POST['category_id']."'";
		}
	}
	if( isset($_POST['station'])) {
		if( $_POST['station'] != 0 ) {
			$station = $_POST['station'];
			$options .= " AND channel_id = '".$_POST['station']."'";
		}
	}

	if( isset($_POST['lines'])) {
			$lines = $_POST['lines'];
	}

}
//$options .= " ORDER BY starttime ASC LIMIT $lines";
$options .= "and not channel_id in (select id from Recorder_channelTbl where skip ='1') ORDER BY starttime,channel_id ASC LIMIT $lines";

$do_keyword = 0;
if( ($search != "") || ($type != "*") || ($category_id != 0) || ($station != 0) )
	$do_keyword = 1;

try{
	
	$precs = DBRecord::createRecords(PROGRAM_TBL, $options );
	
	$programs = array();
	foreach( $precs as $p ) {
		$ch  = new DBRecord(CHANNEL_TBL, "id", $p->channel_id );
		$cat = new DBRecord(CATEGORY_TBL, "id", $p->category_id );
		$arr = array();
		$arr['type'] = $p->type;
		$arr['station_name'] = $ch->name;
		$arr['starttime'] = $p->starttime;
		$arr['endtime'] = $p->endtime;
		$arr['title'] = substr($p->title,0,48);
		$arr['description'] = $p->description;
		$arr['id'] = $p->id;
		$arr['cat'] = $cat->name_en;
		$arr['rec'] = DBRecord::countRecords(RESERVE_TBL, "WHERE program_id='".$p->id."'");
        //既に始まっている番組にマークをしておく
                $arr['started'] = DBRecord::countRecords(PROGRAM_TBL, "WHERE id='".$p->id."' AND starttime < '".date("Y-m-d H:i:s", time())."'");
		
		array_push( $programs, $arr );
	}
	
	$k_category_name = "";
	$crecs = DBRecord::createRecords(CATEGORY_TBL );
	$cats = array();
	$cats[0]['id'] = 0;
	$cats[0]['name'] = "すべて";
	$cats[0]['selected'] = $category_id == 0 ? "selected" : "";
	foreach( $crecs as $c ) {
		$arr = array();
		$arr['id'] = $c->id;
		$arr['name'] = $c->name_jp;
		$arr['selected'] = $c->id == $category_id ? "selected" : "";
		if( $c->id == $category_id ) $k_category_name = $c->name_jp;
		array_push( $cats, $arr );
	}
	
	$types = array();
	$types[0]['name'] = "すべて";
	$types[0]['value'] = "*";
	$types[0]['selected'] = $type == "*" ? "selected" : "";
	if( $settings->gr_tuners != 0 ) {
		$arr = array();
		$arr['name'] = "GR";
		$arr['value'] = "GR";
		$arr['selected'] = $type == "GR" ? "selected" : "";
		array_push( $types, $arr );
	}
	if( $settings->bs_tuners != 0 ) {
		$arr = array();
		$arr['name'] = "BS";
		$arr['value'] = "BS";
		$arr['selected'] = $type == "BS" ? "selected" : "";
		array_push( $types, $arr );
	}
	
	$k_station_name = "";
	$ch_options .= "where skip!='1' ORDER BY id";
	$crecs = DBRecord::createRecords(CHANNEL_TBL, $ch_options);
//	$crecs = DBRecord::createRecords(CHANNEL_TBL);
	$stations = array();
	$stations[0]['id'] = 0;
	$stations[0]['name'] = "すべて";
	$stations[0]['selected'] = (! $station) ? "selected" : "";
	foreach( $crecs as $c ) {
		$arr = array();
		$arr['id'] = $c->id;
		$arr['name'] = $c->name;
		$arr['selected'] = $station == $c->id ? "selected" : "";
		if( $station == $c->id ) $k_station_name = $c->name;
		array_push( $stations, $arr );
	}

	$smarty = new Smarty();
	$smarty->assign("sitetitle","番組検索");
	$smarty->assign("do_keyword", $do_keyword );
	$smarty->assign( "programs", $programs );
	$smarty->assign( "cats", $cats );
	$smarty->assign( "k_category", $category_id );
	$smarty->assign( "k_category_name", $k_category_name );
	$smarty->assign( "types", $types );
	$smarty->assign( "k_type", $type );
	$smarty->assign( "search" , $search );
	$smarty->assign( "use_regexp", $use_regexp );
	$smarty->assign( "stations", $stations );
	$smarty->assign( "k_station", $station );
	$smarty->assign( "k_station_name", $k_station_name );
	$smarty->assign( "remain_t" , $remain_t );
	$smarty->assign( "lines" , $lines );
	$smarty->assign( "stime" , $stime );
	$smarty->assign( "username" , $username );
	$smarty->display("iprogramTable.html");
}
catch( exception $e ) {
	exit( $e->getMessage() );
}
}
?>
